{#-#####################################################################
 # Jinja2 template for /etc/network/interfaces
 #======================================================================
 # Macros responsible for the generation of inet stanzas
 ####################################################################-#}
{#======================================================================
 # Generate bootp stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet bootp' stanza.
 #===================================================================-#}
{%- macro generate_bootp_stanza(interface, indexes) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set bootp   = interface['inet4']['bootp'] -%}

  {#--------------------------------------------------------------------
   # BOOTP options
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set bootp_is_enabled  = bootp['enabled'] -%}
  {%- set bootp_file   = bootp['file'] -%}
  {%- set bootp_server = bootp['server'] -%}

  {%- if bootp_is_enabled is sameas true -%}
    {{ lines.append(header_prefix ~ "bootp" ~ header_suffix) }}

    {%- if bootp_file -%}
      {{ lines.append(TAB ~ "bootfile " ~ bootp_file) }}
    {%- endif -%}

    {%- if bootp_server -%}
      {{ lines.append(TAB ~ "server " ~ bootp_server) }}
    {%- endif -%}

    {#- Separate stanzas -#}
    {%- if interface['desc'] -%}
      {{ lines.append("# " ~ interface['desc']) }}
    {%- endif -%}
    {{ lines.append("") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {%- if lines -%}
    {{ helpers.render_stanza(device, "inet", "bootp", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate dhcp stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet dhcp' stanza.
 #===================================================================-#}
{%- macro generate_dhcp_stanza(interface, indexes) -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set dhcp = interface['inet4']['dhcp'] -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set dhcp_is_enabled  = dhcp['enabled'] -%}

  {%- if dhcp_is_enabled is sameas true -%}
    {{ helpers.render_stanza(device, "inet", "dhcp", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate manual stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet manual' stanza.
 #===================================================================-#}
{%- macro generate_manual_stanza(interface, indexes) -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {{ helpers.render_stanza(device, "inet", "manual", lines, desc) }}
{%- endmacro -%}

{#======================================================================
 # Generate static stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet static' stanza.
 #===================================================================-#}
{%- macro generate_static_stanza(interface, indexes, alias) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#--------------------------------------------------------------------
   # IPv4 address and prefix netmask
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set alias_str = alias['address'] ~ '/' ~ alias['length'] -%}
  {%- set alias_host = alias_str | ipv4('host/prefix') -%}

  {#- Alias address -#}
  {{ lines.append(
      TAB ~ "address " ~ alias_host | ipaddr('address'))
  }}
  {#- Alias netmask -#}
  {{ lines.append(
      TAB ~ "netmask " ~ alias_host | ipaddr('netmask'))
  }}

  {#--------------------------------------------------------------------
   # Static broadcast address
   #------------------------------------------------------------------#}
  {#- Build options -#}
  {%- if 'broadcast' in alias and alias['broadcast'] -%}
    {{ lines.append(
        TAB ~ "broadcast " ~ alias['broadcast'])
    }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Default gateway
   #------------------------------------------------------------------#}
  {%- if 'gateway' in alias and 'address' in alias['gateway'] -%}
    {{ lines.append(
        TAB ~ "gateway " ~ alias['gateway']['address'])
    }}
    {%- if 'metric' in alias['gateway'] -%}
      {{ lines.append(
          TAB ~ "metric " ~ alias['gateway']['metric'] | int)
      }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {%- if lines -%}
    {{ helpers.render_stanza(device, "inet", "static", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate static stanzas
 #----------------------------------------------------------------------
 # Wrapper around generate_static_stanza()
 #===================================================================-#}
{%- macro generate_static_stanzas(interface, indexes) -%}
  {%- for alias in interface['inet4']['static'] -%}
    {%- set static_stanza =
        generate_static_stanza(interface, indexes, alias) -%}
    {%- if static_stanza -%}
      {{ static_stanza ~ "\n" }}
    {%- endif -%}
  {%- endfor -%}
{%- endmacro -%}

{#======================================================================
 # Generate all inet stanzas
 #----------------------------------------------------------------------
 # This macro is responsible for generating zero, one or several inet
 # stanzas for the supplied interface, depending on its configuration.
 #===================================================================-#}
{%- macro generate(interface, indexes, common_stanza) -%}

  {#- Fetch config settings -#}
  {%- set ipv4_is_enabled = interface['inet4']['enabled'] -%}

  {#- We only proceed if IPv4 is enabled on the interface -#}
  {%- if ipv4_is_enabled is sameas true -%}

    {#- Generate 'inet static' stanzas -#}
    {%- set static_stanzas =
        generate_static_stanzas(interface, indexes) -%}
    {%- if static_stanzas -%}
      {{ static_stanzas }}
    {%- endif -%}

    {#- Generate the 'inet bootp' stanza -#}
    {%- set bootp_stanza = generate_bootp_stanza(interface, indexes) -%}
    {%- if bootp_stanza -%}
      {{ bootp_stanza ~ "\n" }}
    {%- endif -%}

    {#- Generate the 'inet dhcp' stanza -#}
    {%- set dhcp_stanza = generate_dhcp_stanza(interface, indexes) -%}
    {%- if dhcp_stanza -%}
      {{ dhcp_stanza ~ "\n" }}
    {%- endif -%}

    {#- Generate an 'inet manual' default stanza as a fallback -#}
    {%- if  not common_stanza
        and not static_stanzas
        and not bootp_stanza
        and not dhcp_stanza
    -%}
      {%- set manual_stanza =
          generate_manual_stanza(interface, indexes) -%}
      {%- if manual_stanza -%}
        {{ manual_stanza ~ "\n" }}
      {%- endif -%}
    {%- endif -%}

  {%- endif -%}
{%- endmacro -%}
